{% extends "base.html" %}
{% load static %}
{% load vstatic %}
{% load i18n %}
{% load rules %}
{% load custom_tags %}
{% load crispy_forms_tags %}
{% block content %}
    {% has_perm 'territorio.visualizar' user object as pode_visualizar_territorio %}
    {% has_perm 'territorio.alterar' user as pode_alterar_territorio %}
    {% has_perm 'territorio.apagar' user as pode_apagar_territorio %}
    {% has_perm 'territorio.status_revisao.alterar' user object as pode_alterar_status_revisao_territorio %}
    {% if pode_visualizar_territorio %}
        <div class="row territorio_detail">
            <div class="col-md-12">
                <div class="territorio_detail_title">
                    <h1>Comunidade {{ object }}</h1>
                    {% if pode_alterar_territorio or pode_alterar_status_revisao_territorio %}
                        <h3>
                            <a class="btn btn-primary" href="{{ object.get_messages_url }}">
                                <i class="fa fa-comments mr-1"></i> {% trans "Mensagens" %}
                            </a>
                            <a class="btn btn-primary"
                               href="{% url 'territorio_report' object.id %}">
                                <i class="fa fa-file mr-1"></i> {% trans "Relatório" %}
                            </a>
                        </h3>
                    {% endif %}
                </div>
            </div>
        </div>
        <div class="row territorio_detail">
            <div class="col-md-12">
                {% if object.teste %}
                    <h4 class="alert alert-warning">
                        <i class="fa fa-exclamation-circle mr-2"></i> Esta comunidade
                        <b>é de testes!</b>
                    </h4>
                {% elif object.publico %}
                    <h4 class="alert alert-success">
                        <i class="fa fa-check-circle mr-2"></i> Esta comunidade
                        <b>autoriza</b> a divulgação pública de suas informações.
                    </h4>
                {% else %}
                    <h4 class="alert alert-error">
                        <i class="fa fa-exclamation-circle mr-2"></i> Esta comunidade
                        <b>não autoriza</b> a divulgação pública de suas informações.
                    </h4>
                {% endif %}
            </div>
        </div>
        <div class="row territorio_detail">
            <div class="col-xs-12 col-sm-12 col-md-12 mt-2" id="map_wrapper">
                <div id="map" class="map_container"></div>
                <div id="nomap" class="d-none">
                    <div class="jumbotron jumbotron-warning">
                        <p>
                            <strong>Mapa indisponível</strong>
                            <br />
                            Esta comunidade
                            ainda não tem polígonos nem áreas de uso ou de conflito
                            cadastradas.
                        </p>
                    </div>
                </div>
            </div>
        </div>
        <div class="row territorio-info territorio_detail">
            <div class="col-xs-12 col-sm-6 col-md-6">
                <dl>
                    {% if not user.is_parceira %}
                        <dt>Pessoa cadastrante</dt>
                        <dd>
                            {% if object.cadastrantes %}
                                {% for cadastrante in object.cadastrantes %}
                                    {% if cadastrante %}
                                        {% if pode_alterar_territorio %}
                                            <a href="{% url 'usuaria_update' cadastrante.id %}">
                                                <span class="mr-2">{{ cadastrante }}</span>
                                                {{ cadastrante.username|format_telefone }}
                                            </a>
                                        {% else %}
                                            <span class="mr-2">{{ cadastrante }}</span>
                                            {{ cadastrante.username|format_telefone }}
                                        {% endif %}
                                    {% endif %}
                                    {% if not forloop.last %},{% endif %}
                                {% endfor %}
                            {% else %}
                                <i class="small">(Não há cadastrante associada/o.)</i>
                            {% endif %}
                        </dd>
                        <dt>Revisor/a</dt>
                        <dd>
                            {% if object.revisora %}
                                {% if pode_alterar_territorio %}
                                    <a href="{% url 'usuaria_update' object.revisora.id %}">{{ object.revisora }}</a>
                                {% else %}
                                    {{ object.revisora }}
                                {% endif %}
                            {% else %}
                                <i class="small">(Não há revisor/a associado/a.)</i>
                            {% endif %}
                        </dd>
                    {% endif %}
                    <dt>Data de cadastro</dt>
                    <dd>
                        {{ object.criacao }}
                    </dd>
                    <dt>Data de validação</dt>
                    <dd>
                        {{ object.data_validacao }}
                    </dd>
                    <dt>Área</dt>
                    <dd>
                        <span id="spanTerritorioArea">-</span>
                        {% if not user.is_reviewer %}
                            <button id="baixaKML" class="btn btn-secondary btn-sm d-none">
                                <i class="fa fa-download"></i> KML
                            </button>
                        {% endif %}
                    </dd>
                    <dt>Tipo(s) de Comunidade</dt>
                    <dd>
                        {% for tipo_comunidade in object.tipos_comunidade.all %}
                            {{ tipo_comunidade }}
                            {% if not forloop.last %},{% endif %}
                        {% empty %}
                            <i class="small">(Não foram definidos segmentos.)</i>
                        {% endfor %}
                    </dd>
                    <dt>Município de Referência</dt>
                    <dd>
                        {{ object.municipio_referencia|default_if_none:'<i class="small">(Não especificado.)</i>'|safe }}
                    </dd>
                    <dt>Bioma</dt>
                    <dd>
                        {{ object.bioma|default_if_none:'<i class="small">(Não identificado.)</i>'|safe }}
                    </dd>
                    <dt>Quantidade de famílias</dt>
                    <dd>
                        {{ object.qtde_familias|default_if_none:'<i class="small">(Não especificado.)</i>'|safe }}
                    </dd>
                    <dt>Ano em que foi fundada</dt>
                    <dd>
                        {{ object.ano_fundacao|default_if_none:'<i class="small">(Não especificado.)</i>'|safe }}
                    </dd>
                    <dt>Áreas de uso</dt>
                    <dd>
                        {{ object.areas_de_uso_unique|join:", "|default:'<i class="small">(Não especificadas.)</i>'|safe }}
                    </dd>
                    <dt>Conflitos</dt>
                    <dd>
                        {{ object.conflitos_unique|join:", "|default:'<i class="small">(Não especificados.)</i>'|safe }}
                    </dd>
                </dl>
            </div>
            <div class="col-xs-12 col-sm-6 col-md-6 mt-3">
                {% if pode_alterar_status_revisao_territorio %}
                    {% crispy form %}
                {% endif %}
            </div>
        </div>
        <div class="row mt-3 territorio_detail">
            <div class="col-md-12">
                <div class="x_panel">
                    <div class="x_title">
                        <h2>Ata</h2>
                        <ul class="nav navbar-right panel_toolbox">
                            <li>
                                <a class="collapse-link">
                                    <i class="fa fa-chevron-up"></i>
                                </a>
                            </li>
                        </ul>
                        <div class="clearfix"></div>
                    </div>
                    <div class="x_content">
                        <div class="row">
                            {% if object.tem_ata %}
                                {% for anexo in object.anexos.all %}
                                    {% if anexo.tipo_anexo == 'ata' and anexo.thumbnail_tag %}
                                        <div class="col-md-55 anexo_container">
                                            <div class="thumbnail">
                                                <div class="image view view-first">
                                                    <a href="{{ anexo.arquivo.url }}" target="_blank">{{ anexo.thumbnail_tag|safe }}</a>
                                                </div>
                                                <div class="caption">
                                                    <p class="anexo_titulo">{{ anexo|default_if_none:"Arquivo de ata" }}</p>
                                                    {% if anexo.descricao %}<p class="anexo_descricao">{{ anexo.descricao }}</p>{% endif %}
                                                </div>
                                            </div>
                                        </div>
                                    {% endif %}
                                {% endfor %}
                            {% else %}
                                <div class="col-sm-12">
                                    <i>Ata não foi anexada.</i>
                                </div>
                            {% endif %}
                        </div>
                    </div>
                </div>
            </div>
        </div>
        {% if pode_alterar_status_revisao_territorio or user.is_parceira %}
            <div class="row mt-3 territorio_detail">
                <div class="col-md-12">
                    <div class="x_panel">
                        <div class="x_title">
                            <h2>Anexos</h2>
                            <ul class="nav navbar-right panel_toolbox">
                                <li>
                                    <a class="collapse-link">
                                        <i class="fa fa-chevron-up"></i>
                                    </a>
                                </li>
                            </ul>
                            <div class="clearfix"></div>
                        </div>
                        <div class="x_content">
                            <div class="row">
                                {% for anexo in object.anexos.all %}
                                    {% if not anexo.tipo_anexo or anexo.tipo_anexo != 'ata' %}
                                        {% if anexo.thumbnail_tag %}
                                            <div class="col-md-55 anexo_container">
                                                <div class="thumbnail">
                                                    <div class="image view view-first">
                                                        <a href="{{ anexo.arquivo.url }}" target="_blank">{{ anexo.thumbnail_tag|safe }}</a>
                                                    </div>
                                                    <div class="caption">
                                                        <p class="anexo_titulo">{{ anexo|default_if_none:"Anexo" }}</p>
                                                        {% if anexo.descricao %}<p class="anexo_descricao">{{ anexo.descricao }}</p>{% endif %}
                                                    </div>
                                                </div>
                                            </div>
                                        {% endif %}
                                    {% endif %}
                                {% empty %}
                                    <div class="col-md-12">
                                        <i>Não há anexos.</i>
                                    </div>
                                {% endfor %}
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        {% endif %}
        {% if pode_apagar_territorio %}
            <div class="row territorio_detail">
                <div class="col-md-12">
                    <p class="pull-right">
                        <button class="btn btn-danger"
                                onclick="if(confirm('Deseja realmente apagar esta comunidade?')) window.location='{% url 'territorio_delete' object.id %}'">
                            Apagar
                        </button>
                    </p>
                </div>
            </div>
        {% endif %}
    {% endif %}
    <script>
        {% autoescape off %}
            const MAPBOX_ACCESS_TOKEN = '{{ MAPBOX_ACCESS_TOKEN }}';
            const SITE_URL = '{{ SITE_URL }}';
            const icone_url = "{% vstatic 'main/img' %}".split('?')[0];
            const position_initial = {% if object.geo_poligonos or object.geo_areas_uso or object.conflitos.count %}{{ object.geo_posicao_inicial }}{% else %}[]{% endif %};
            const isSinglePage = true;
            let territorios = [{
                id: {{ territorio.id }},
                nome: '{{ territorio.nome|escapejs }}',
                conflitos: {{ territorio.conflitos }},
                areasDeUso: {{ territorio.areas_de_uso }},
                poligonos: {{ territorio.poligonos }},
                area: '{{ territorio.area }}',
                kml: '{{ territorio.kml }}',
                poligonoMarker: [],
                territorio_url: null
            }];

            const area = parseFloat(territorios[0].area.replace(',', '.'));
            if (area) {
                $('#spanTerritorioArea').text(formataArea(area, UNIDADES_AREA.METRO_QUADRADO));
                $('#baixaKML').removeClass('d-none');
                $('#baixaKML').on('click', function() {
                    baixaKML({
                        nome: "{{ object }}",
                        kml: territorios[0].kml,
                    });
                });
            } else {
                $('#spanTerritorioArea').html("<i class='small'>(Não há polígonos.)</i>");
            }
        {% endautoescape %}
        {% if pode_alterar_status_revisao_territorio %}
            $('form').on('submit', function() {
                $('#id_status_revisao').prop("disabled", false);
                $('#id_status_revisao option').prop('disabled', false)
            });
            const None = null;
            const MAPA_STATUS_REV = {{ MAPA_STATUS_REV }};
            if (
                [
                    '{{ territorio_revisao_status.EM_PREENCHIMENTO_TONOMAPA }}',
                    '{{ territorio_revisao_status.REVISADO_COM_PENDENCIAS }}',
                    '{{ territorio_revisao_status.ENVIADO_PTT }}',
                    '{{ territorio_revisao_status.ENVIADO_PTT_NAFILA }}',
                    '{{ territorio_revisao_status.ENVIADO_PTT_NAFILA_ARQUIVOS }}'
                ].includes($('#id_status_revisao').val())
            ) {
                $('#id_status_revisao').attr("disabled", "disabled");
                // $('#submit-id-submit').attr("disabled", "disabled");
            }

            $("#id_status_revisao option[value='{{ territorio_revisao_status.EM_PREENCHIMENTO_TONOMAPA }}']").attr("disabled","disabled");
            $("#id_status_revisao option[value='{{ territorio_revisao_status.ENVIADO_PTT }}']").attr("disabled","disabled");
            $("#id_status_revisao option[value='{{ territorio_revisao_status.ENVIADO_PTT_NAFILA }}']").attr("disabled","disabled");
            $("#id_status_revisao option[value='{{ territorio_revisao_status.ENVIADO_PTT_NAFILA_ARQUIVOS }}']").attr("disabled","disabled");

            $('#id_status_revisao').change(function () {
                updateStatusAndMensagem($(this).val());
            });

            toggleMensagem($('#id_status_revisao').val());

            function updateStatusAndMensagem(val) {
                $('#id_status').val(MAPA_STATUS_REV[val]);
                toggleMensagem(val);
            }

            function toggleMensagem(val) {
                const showMensagem = [
                    {{ territorio_revisao_status.APROVADO }},
                    {{ territorio_revisao_status.REVISADO_COM_PENDENCIAS }},
                    {{ territorio_revisao_status.REJEITADO }}
                ].includes(parseInt(val));
                $('#div_id_mensagem').toggle(showMensagem, 300);
            }
        {% endif %}
    </script>
{% endblock content %}
{% block includes %}
    <link rel="stylesheet"
          href="https://unpkg.com/leaflet@1.7.1/dist/leaflet.css"
          integrity="sha512-xodZBNTC5n17Xt2atTPuE1HxjVMSvLVW9ocqUKLsCC5CXdbqCmblAshOMAS6/keqq/sMZMZ19scR4PsZChSR7A=="
          crossorigin="" />
    <script src="https://unpkg.com/leaflet@1.7.1/dist/leaflet.js"
            integrity="sha512-XQoYMqMTK8LvdxXYG3nZ448hOEQiglfqkJs1NOQV44cWnUrBc8PkAOcXy20w0vlaXaVUearIOBhiXZ5V3ynxwA=="
            crossorigin=""></script>
    <script src="https://unpkg.com/dom-to-image@2.6.0/dist/dom-to-image.min.js"></script>
    <link rel="stylesheet"
          href="https://cdn.jsdelivr.net/npm/leaflet-easybutton@2/src/easy-button.css" />
    <script src="https://cdn.jsdelivr.net/npm/leaflet-easybutton@2/src/easy-button.js"></script>
    <script type="text/javascript"
            src="{% vstatic 'main/js/app_kml_formatter.js' %}"></script>
    <script type="text/javascript" src="{% vstatic 'main/js/app_mapa.js' %}"></script>
    <link href="{% vstatic 'main/css/dashboard_mapa.css' %}" rel="stylesheet" />
{% endblock includes %}
